{{
  Karplus-Strong demo
}}

CON
  _clkmode      = xtal1 + pll16x
  _xinfreq      = 5_000_000
  sr            = 44_100        ' let's run at the CD sampling rate
  sustain_value = 8
  demo_pinL     = 11
  demo_pinR     = 10

OBJ
  term          : "FullDuplexSerial"
  ks[2]         : "Karplus-Strong"                      ' left channel information should be heard from your left speaker...

PUB test_KS | rn, p

  ' set up my serial port, and wait for the BST terminal to go live
  term.start( 31, 30, 0, 115_200 )

  ' set up using the demo board pins for the headphones
  ks[0].start( demo_pinL, -1, sr, sustain_value, 0 )
  ks[1].start( demo_pinR, -1, 78_901, sustain_value, 0 )

  waitcnt( clkfreq >> 3 + cnt )

  { test the 2 different modes:
  p := constant( (buf_size - 2) << fraction_bits )
  pluck( p - 1, 31 )
  waitcnt( clkfreq / 1 + cnt )
  stop
  term.str( string( 13, 13, "sample,value", 13 ) )
  repeat rn from 0 to constant( buf_size - 1 )
    term.dec( rn )
    term.tx( "," )
    term.dec( ~~buf[rn] )
    term.tx( 13 )
  repeat
  '}

  ' play the scale
  rn := 10
  repeat
    ' wait a bit
    waitcnt( clkfreq / 4 + cnt )
    ' pluck a note (MIDI spec) and returns the period
    ks[0].pluck_note( rn, 31 )
    p := ks[1].pluck_note( rn, 31 )
    ' debug
    term.dec( rn )
    term.tx( "," )
    term.dec( p )
    term.tx( 13 )
    ' next note?
    ++rn
    rn //= 128
    { do a quick loop around the doubler transition point
    if rn > 50
      rn := 30
      waitcnt( clkfreq * 3 / 4 + cnt )
    '}
